package com.redhat;


import org.apache.camel.Exchange;
import org.apache.camel.Processor;
import org.apache.camel.builder.RouteBuilder;
import org.apache.camel.dataformat.bindy.csv.BindyCsvDataFormat;
import org.apache.camel.model.dataformat.BindyType;
import org.apache.camel.spi.DataFormat;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class CamelServiceRoute extends RouteBuilder {

	private DataFormat bindy = new BindyCsvDataFormat(SimDataRow.class);
    private static final Logger LOGGER = LoggerFactory.getLogger(CamelServiceRoute.class);
	/**
	 * The Camel route is configured via this method.  The from endpoint is required to be a SwitchYard service.
	 */
	public void configure() {
		// TODO Auto-generated method stub
		from("switchyard://BindyService")
		.log("**********---************ Received An Infile ").doTry()
		.log("----------------------------------------\n")
		.log(body().toString())
		.log("----------------------------------------\n")
		 .unmarshal(bindy)
		.process(new SignalTransformer())
        .to("switchyard://BindyReference")
        .doCatch(Exception.class).process(new ExceptionHandler())
		.end();
		
		
		// .unmarshal().bindy(BindyType.Csv,SimDataRow.class)
	}
	
	 private class SignalTransformer implements Processor {

	        @Override
	        public void process(Exchange exchange) throws Exception {
	        	LOGGER.info("Inside Signal Trasformer "+exchange);
	        }
	    }
	
	private class ExceptionHandler implements Processor {

        @Override
        public void process(Exchange exchange) throws Exception {
            Exception exception =
                    exchange.getProperty(org.apache.camel.Exchange.EXCEPTION_CAUGHT,
                            Exception.class);
            LOGGER.warn("Failed to handle infile", exception);
        }
    }
}
